#|
According to MIT Scheme's runtime.pkg file, it should be syntactic-closures, syntax-output, syntax-transforms, mit-syntax, 
syntax-rules, syntax-check. But that looks wrong: syntax-transforms defines stuff necessary for some top-level expressions 
in syntactic-closures. scm.
|#

(define lambda-optional-tag '#!optional)
(define lambda-rest-tag '#!rest)
(define unspecific (void))
(define (environment? x) (##sys#structure? x 'environment))
(define (delete-matching-items! list pred)
  (remove! pred list))
(define (environment-lookup-macro env id) #f)

(load "record.scm")

(load "syntax-transforms.scm")
(initialize-syntax-transforms!)
(load "syntactic-closures.scm")

(define system-global-environment (make-top-level-syntactic-environment (scheme-report-environment 5)))

(load "syntax-output.scm")
(load "mit-syntax.scm")
(load "syntax-rules.scm")
(load "syntax-check.scm")

(debug #t)

(pp (syntax 1 system-global-environment))
(pp (syntax '(if 1 2 3) system-global-environment))
(pp (syntax '(define abc 99) system-global-environment))
(pp (syntax '(let ((x 1)) x) system-global-environment))
